var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, EventEmitter, ChangeDetectionStrategy, HostListener, Output, TemplateRef } from '@angular/core';
var ActionButtonComponent = (function () {
    function ActionButtonComponent() {
        this.type = 'default';
        this.direction = 'down';
        this.isOpen = false;
        this.disabled = false;
        this.actionClick = new EventEmitter();
        this.openStatusChange = new EventEmitter();
    }
    ActionButtonComponent.prototype.toggle = function ($event) {
        if ($event) {
            $event.stopPropagation();
        }
        this.isOpen = !this.isOpen;
        this.openStatusChange.emit(this.isOpen);
    };
    ActionButtonComponent.prototype.close = function ($event) {
        this.isOpen = false;
        this.openStatusChange.emit(this.isOpen);
    };
    ActionButtonComponent.prototype.onActionClick = function (item) {
        if (!item.disabled) {
            this.close();
            this.actionClick.emit(item);
        }
    };
    return ActionButtonComponent;
}());
__decorate([
    Input(),
    __metadata("design:type", String)
], ActionButtonComponent.prototype, "type", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], ActionButtonComponent.prototype, "direction", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], ActionButtonComponent.prototype, "icon", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], ActionButtonComponent.prototype, "btnSize", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], ActionButtonComponent.prototype, "buttonText", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], ActionButtonComponent.prototype, "cssClass", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], ActionButtonComponent.prototype, "isOpen", void 0);
__decorate([
    Input(),
    __metadata("design:type", Array)
], ActionButtonComponent.prototype, "actions", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], ActionButtonComponent.prototype, "disabled", void 0);
__decorate([
    Input(),
    __metadata("design:type", TemplateRef)
], ActionButtonComponent.prototype, "buttonTemplate", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], ActionButtonComponent.prototype, "actionClick", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], ActionButtonComponent.prototype, "openStatusChange", void 0);
__decorate([
    HostListener('document:click', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [MouseEvent]),
    __metadata("design:returntype", void 0)
], ActionButtonComponent.prototype, "close", null);
ActionButtonComponent = __decorate([
    Component({
        selector: 're-action-button',
        template: "\n    <template #defaultButtonTemplate let-action>\n      <button class=\"btn {{action.type? 'btn-' + action.type : ''}} {{action.btnSize? 'btn-' + action.btnSize : ''}}\"\n              (click)=\"action.toggle($event)\"\n              [disabled]=\"action.disabled\">\n        <i *ngIf=\"action.icon\" class=\"{{action.icon}}\" aria-hidden=\"true\"></i>\n        {{action.buttonText}}\n      </button>\n      <button type=\"button\"\n              class=\"btn {{action.type? 'btn-' + action.type : ''}} {{action.btnSize? 'btn-' + action.btnSize : ''}} dropdown-toggle\"\n              aria-haspopup=\"true\"\n              [attr.aria-expanded]=\"true\"\n              (click)=\"action.toggle($event)\" [disabled]=\"action.disabled\">\n        <span class=\"caret\"></span>\n        <span class=\"sr-only\">|</span>\n      </button>\n    </template>\n\n    <div class=\"btn-group {{direction? 'drop' + direction : '' }} {{cssClass}}\" [ngClass]=\"{open: isOpen}\">\n\n      <template [ngTemplateOutlet]=\"buttonTemplate || defaultButtonTemplate\"\n                [ngOutletContext]=\"{ $implicit: this}\"></template>\n\n      <ul class=\"dropdown-menu\" role=\"menu\">\n        <ng-container *ngFor=\"let item of actions\">\n          <li *ngIf=\"!item.divider && ! item.header\" role=\"menuitem\" [ngClass]=\"{'disabled': item.disabled}\"\n              (click)=\"onActionClick(item)\">\n            <a><i *ngIf=\"item.icon\" class=\"{{item.icon}}\"></i>&nbsp;{{item.text}}</a></li>\n          <li *ngIf=\"item.header\" class=\"dropdown-header\">{{item.text}}</li>\n          <li *ngIf=\"item.divider\" class=\"divider\" role=\"separator\"></li>\n        </ng-container>\n      </ul>\n    </div>\n  ",
        changeDetection: ChangeDetectionStrategy.OnPush,
    })
], ActionButtonComponent);
export { ActionButtonComponent };
//# sourceMappingURL=action-button.component.js.map