import { ChangeDetectorRef, ComponentFactoryResolver, ElementRef, EventEmitter, Injector, OnDestroy, OnInit, Renderer, TemplateRef, ViewContainerRef } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { Observable } from 'rxjs/Observable';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/filter';
import 'rxjs/add/operator/debounceTime';
import 'rxjs/add/operator/distinctUntilChanged';
import 'rxjs/add/operator/switchMap';
import 'rxjs/add/operator/do';
import { RebirthUIConfig } from '../rebirth-ui.config';
import { PositionService } from '../position/positioning.service';
export declare class AutoCompleteDirective implements OnInit, OnDestroy, ControlValueAccessor {
    private elementRef;
    private viewContainerRef;
    private componentFactoryResolver;
    private renderer;
    private injector;
    private positionService;
    private rebirthUIConfig;
    private changeDetectorRef;
    disabled: boolean;
    cssClass: string;
    delay: number;
    minLength: number;
    itemTemplate: TemplateRef<any>;
    noResultItemTemplate: TemplateRef<any>;
    formatter: (item: any) => string;
    valueParser: (item: any) => any;
    onSearch: (term: string, target?: AutoCompleteDirective) => Observable<any[]>;
    selectValue: EventEmitter<any>;
    private valueChanges;
    private value;
    private placement;
    private subscription;
    private popupRef;
    private onChange;
    private onTouched;
    constructor(elementRef: ElementRef, viewContainerRef: ViewContainerRef, componentFactoryResolver: ComponentFactoryResolver, renderer: Renderer, injector: Injector, positionService: PositionService, rebirthUIConfig: RebirthUIConfig, changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    writeValue(obj: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    ngOnDestroy(): void;
    onBlur(): void;
    onEscKeyup($event: any): void;
    onEnterKeyDown($event: any): void;
    onArrowUpKeyDown($event: any): void;
    onArrowDownKeyDown($event: any): void;
    onDocumentClick($event: Event): void;
    onSourceChange(source: any): void;
    private hidePopup();
    private positionPopup();
    private fillPopup(source?, term?);
    private writeInputValue(value);
    private unSubscription();
    private onTermChange(term);
    private registerInputEvent(elementRef);
}
