var RebirthRouterReuseStrategy = (function () {
    function RebirthRouterReuseStrategy() {
        this.handlers = {};
    }
    RebirthRouterReuseStrategy.prototype.shouldDetach = function (route) {
        return true;
    };
    RebirthRouterReuseStrategy.prototype.store = function (route, handle) {
        this.handlers[route.routeConfig.path] = handle;
    };
    RebirthRouterReuseStrategy.prototype.shouldAttach = function (route) {
        return !!route.routeConfig && !!this.handlers[route.routeConfig.path];
    };
    RebirthRouterReuseStrategy.prototype.retrieve = function (route) {
        return route.routeConfig ? this.handlers[route.routeConfig.path] : null;
    };
    RebirthRouterReuseStrategy.prototype.shouldReuseRoute = function (future, curr) {
        return future.routeConfig === curr.routeConfig;
    };
    return RebirthRouterReuseStrategy;
}());
export { RebirthRouterReuseStrategy };
//# sourceMappingURL=router-reuse-strategy.js.map