var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy, Input, HostListener, ChangeDetectorRef } from '@angular/core';
import { DataTableColumnTmplComponent } from './tmpl/data-table-column-tmpl.component';
import { DataTableComponent } from './data-table.component';
import { DataTableTmplsComponent } from './tmpl/data-table-tmpls.component';
import { DataTableRowComponent } from './data-table-row.component';
var DataTableCellComponent = (function () {
    function DataTableCellComponent(dt, changeDetectorRef, rowComponent) {
        this.dt = dt;
        this.changeDetectorRef = changeDetectorRef;
        this.rowComponent = rowComponent;
    }
    DataTableCellComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.forceUpdateSubscription = this.rowComponent.forceUpdateEvent.subscribe(function (_) { return _this.forceUpdate(); });
    };
    DataTableCellComponent.prototype.onCellClick = function ($event) {
        var _this = this;
        var cellSelectedEventArg = {
            rowIndex: this.rowIndex,
            colIndex: this.colIndex,
            column: this.column,
            rowItem: this.rowItem,
            cellComponent: this,
            rowComponent: this.rowComponent
        };
        this.dt.onCellClick(cellSelectedEventArg);
        if (this.column.editable && this.editModel === 'cell') {
            $event.stopPropagation();
            this.isCellEdit = true;
            this.documentClickubscription = this.dt.documentClickEvent.subscribe(function (_) { return _this.onFinishCellEdit(); });
            this.dt.onCellEditStart(cellSelectedEventArg);
        }
    };
    DataTableCellComponent.prototype.forceUpdate = function () {
        this.changeDetectorRef.markForCheck();
    };
    DataTableCellComponent.prototype.onFinishCellEdit = function ($event) {
        if (this.editModel !== 'cell') {
            return;
        }
        this.isCellEdit = false;
        this.unSubscription(this.documentClickubscription);
        if ($event) {
            $event.stopPropagation();
        }
        this.dt.onCellEditEnd({
            rowIndex: this.rowIndex,
            colIndex: this.colIndex,
            column: this.column,
            rowItem: this.rowItem,
            cellComponent: this,
            rowComponent: this.rowComponent
        });
    };
    DataTableCellComponent.prototype.onCellDBClick = function ($event) {
        var cellSelectedEventArg = {
            rowIndex: this.rowIndex,
            colIndex: this.colIndex,
            column: this.column,
            rowItem: this.rowItem,
            cellComponent: this,
            rowComponent: this.rowComponent
        };
        this.dt.onCellDBClick(cellSelectedEventArg);
    };
    DataTableCellComponent.prototype.isCellEditEnable = function (column, rowItem) {
        if (this.editModel === 'cell') {
            return this.isCellEdit;
        }
        return this.isEditRow;
    };
    DataTableCellComponent.prototype.getCellValue = function (column, rowIndex, rowItem) {
        if (!column || !column.field) {
            return null;
        }
        if (column.field === '$index') {
            return rowIndex + 1;
        }
        return rowItem[column.field];
        /*
         * field with dot, like address.line1
         const fields = column.field.split('.');
         return fields.reduce((obj, field) => obj ? obj[field] : null, rowItem);
         */
    };
    DataTableCellComponent.prototype.getCellFormatValue = function (column, rowIndex, rowItem) {
        var cellValue = this.getCellValue(column, rowIndex, rowItem);
        if (column.field !== '$index' && column.formatter) {
            return column.formatter(cellValue);
        }
        return cellValue;
    };
    DataTableCellComponent.prototype.ngOnDestroy = function () {
        this.unSubscription(this.forceUpdateSubscription);
        this.unSubscription(this.documentClickubscription);
    };
    DataTableCellComponent.prototype.unSubscription = function (sbscription) {
        if (sbscription) {
            sbscription.unsubscribe();
            sbscription = null;
        }
    };
    return DataTableCellComponent;
}());
__decorate([
    Input(),
    __metadata("design:type", Number)
], DataTableCellComponent.prototype, "rowIndex", void 0);
__decorate([
    Input(),
    __metadata("design:type", Number)
], DataTableCellComponent.prototype, "colIndex", void 0);
__decorate([
    Input(),
    __metadata("design:type", DataTableColumnTmplComponent)
], DataTableCellComponent.prototype, "column", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DataTableCellComponent.prototype, "rowItem", void 0);
__decorate([
    Input(),
    __metadata("design:type", DataTableTmplsComponent)
], DataTableCellComponent.prototype, "dataTableTemplates", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], DataTableCellComponent.prototype, "editModel", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], DataTableCellComponent.prototype, "isEditRow", void 0);
__decorate([
    HostListener('click', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], DataTableCellComponent.prototype, "onCellClick", null);
__decorate([
    HostListener('dbclick', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], DataTableCellComponent.prototype, "onCellDBClick", null);
DataTableCellComponent = __decorate([
    Component({
        selector: 're-data-table-cell,[reDataTableCell]',
        template: "\n    <ng-container>\n      <template *ngIf=\"!column.editable || !isCellEditEnable(column, rowItem)\"\n                [ngTemplateOutlet]=\"dataTableTemplates.getCellViewTemplate(column)\"\n                [ngOutletContext]=\"{\n                       rowIndex:rowIndex,\n                       colIndex:colIndex,\n                       column: column,\n                       rowItem:rowItem,\n                       cellItem: getCellValue(column, rowIndex, rowItem),\n                       cellValue:  getCellFormatValue(column, rowIndex, rowItem),\n                       $implicit: this,\n                       row: rowComponent\n                       }\">\n      </template>\n\n      <template *ngIf=\"column.editable && isCellEditEnable(column, rowItem)\"\n                [ngTemplateOutlet]=\"dataTableTemplates.getCellEditTemplate(column)\"\n                [ngOutletContext]=\"{\n                        rowIndex:rowIndex,\n                        colIndex:colIndex,\n                        column: column,\n                        rowItem: rowItem?.$editModel || rowItem,\n                        viewItem: rowItem,\n                        $implicit: this,\n                        row: rowComponent\n                        }\">\n      </template>\n    </ng-container>\n  ",
        host: {
            '[class]': 'column.cellClass ? column.cellClass : ""',
        },
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [DataTableComponent, ChangeDetectorRef,
        DataTableRowComponent])
], DataTableCellComponent);
export { DataTableCellComponent };
//# sourceMappingURL=data-table-cell.component.js.map