var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy, Input, ContentChildren, Output, EventEmitter, ContentChild, ViewChild, HostListener } from '@angular/core';
import { DataTableColumnTmplComponent } from './tmpl/data-table-column-tmpl.component';
import { DataTableHeadTmplComponent } from './tmpl/data-table-head-tmpl.component';
import { DataTableFootTmplComponent } from './tmpl/data-table-foot-tmpl.component';
import { DataTableTmplsComponent } from './tmpl/data-table-tmpls.component';
import { DataTablePagerTmplComponent } from './tmpl/data-table-pager-tmpl.component';
var DataTableComponent = (function () {
    function DataTableComponent() {
        this.dataSource = [];
        this.editModel = 'cell';
        this.type = '';
        this.hover = true;
        this.cellClick = new EventEmitter();
        this.cellDBClick = new EventEmitter();
        this.rowClick = new EventEmitter();
        this.rowDBClick = new EventEmitter();
        this.cellEditStart = new EventEmitter();
        this.cellEditEnd = new EventEmitter();
        this.sortChange = new EventEmitter();
        this.rowCheckChange = new EventEmitter();
        this.checkAllChange = new EventEmitter();
        this.searchQueryChange = new EventEmitter();
        this.pageIndexChange = new EventEmitter();
        this.documentClickEvent = new EventEmitter();
    }
    DataTableComponent.prototype.onDocumentClick = function ($event) {
        this.documentClickEvent.emit($event);
    };
    DataTableComponent.prototype.onCellClick = function ($event) {
        this.selectedRowItem = $event.rowItem;
        this.selectedColumnItem = $event.column;
        this.cellClick.emit($event);
    };
    DataTableComponent.prototype.onCellEditStart = function ($event) {
        this.isCellEdit = true;
        this.cellEditStart.emit($event);
    };
    DataTableComponent.prototype.onCellEditEnd = function ($event) {
        this.isCellEdit = false;
        this.cellEditEnd.emit($event);
    };
    DataTableComponent.prototype.onCellDBClick = function ($event) {
        this.cellDBClick.emit($event);
    };
    DataTableComponent.prototype.onRowClick = function ($event) {
        this.selectedRowItem = $event.rowItem;
        this.rowClick.emit($event);
    };
    DataTableComponent.prototype.onRowDBClick = function ($event) {
        this.rowDBClick.emit($event);
    };
    DataTableComponent.prototype.onRowCheckChange = function ($event) {
        this.allChecked = !this.dataSource.some(function (item) { return !item.$$checked; });
        this.rowCheckChange.emit($event);
    };
    DataTableComponent.prototype.onCheckAllChange = function ($event) {
        if (this.dataSource) {
            this.dataSource.forEach(function (item) { return item.$$checked = $event; });
        }
        this.allChecked = $event;
        this.checkAllChange.emit($event);
    };
    DataTableComponent.prototype.onSearchQueryChange = function ($event) {
        this.searchQueryChange.emit($event);
    };
    DataTableComponent.prototype.onPageChange = function ($event) {
        this.pageIndexChange.emit($event);
    };
    DataTableComponent.prototype.getCheckRows = function () {
        return this.dataSource ? this.dataSource.filter(function (item) { return item.$$checked; }) : [];
    };
    DataTableComponent.prototype.getSelectedRowItem = function () {
        return this.selectedRowItem;
    };
    DataTableComponent.prototype.editRow = function (rowItem, editModel) {
        rowItem.$$edit = true;
        rowItem.$$editModel = editModel;
        this.editRowItem = rowItem;
    };
    DataTableComponent.prototype.endEditRow = function (rowItem) {
        var editModel = rowItem.$$editModel;
        delete rowItem.$$edit;
        delete rowItem.$$editModel;
        this.editRowItem = null;
        return editModel;
    };
    DataTableComponent.prototype.ngOnDestroy = function () {
    };
    return DataTableComponent;
}());
__decorate([
    Input(),
    __metadata("design:type", Array)
], DataTableComponent.prototype, "dataSource", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], DataTableComponent.prototype, "checkable", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], DataTableComponent.prototype, "selectable", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], DataTableComponent.prototype, "scrollable", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], DataTableComponent.prototype, "editModel", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], DataTableComponent.prototype, "maxHeight", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], DataTableComponent.prototype, "type", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DataTableComponent.prototype, "hover", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], DataTableComponent.prototype, "allChecked", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], DataTableComponent.prototype, "pager", void 0);
__decorate([
    Input(),
    __metadata("design:type", String)
], DataTableComponent.prototype, "cssClass", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], DataTableComponent.prototype, "cellClick", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], DataTableComponent.prototype, "cellDBClick", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], DataTableComponent.prototype, "rowClick", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], DataTableComponent.prototype, "rowDBClick", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], DataTableComponent.prototype, "cellEditStart", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], DataTableComponent.prototype, "cellEditEnd", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], DataTableComponent.prototype, "sortChange", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], DataTableComponent.prototype, "rowCheckChange", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], DataTableComponent.prototype, "checkAllChange", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], DataTableComponent.prototype, "searchQueryChange", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], DataTableComponent.prototype, "pageIndexChange", void 0);
__decorate([
    ContentChildren(DataTableColumnTmplComponent),
    __metadata("design:type", Array)
], DataTableComponent.prototype, "columns", void 0);
__decorate([
    ContentChild(DataTableHeadTmplComponent),
    __metadata("design:type", DataTableHeadTmplComponent)
], DataTableComponent.prototype, "headTemplate", void 0);
__decorate([
    ContentChild(DataTableFootTmplComponent),
    __metadata("design:type", DataTableFootTmplComponent)
], DataTableComponent.prototype, "footTemplate", void 0);
__decorate([
    ContentChild(DataTablePagerTmplComponent),
    __metadata("design:type", DataTablePagerTmplComponent)
], DataTableComponent.prototype, "pagerTemplate", void 0);
__decorate([
    ViewChild(DataTableTmplsComponent),
    __metadata("design:type", DataTableTmplsComponent)
], DataTableComponent.prototype, "dataTableTemplates", void 0);
__decorate([
    HostListener('document:click', ['$event']),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Event]),
    __metadata("design:returntype", void 0)
], DataTableComponent.prototype, "onDocumentClick", null);
DataTableComponent = __decorate([
    Component({
        selector: 're-data-table',
        template: "\n    <re-data-table-templates></re-data-table-templates>\n\n    <div class=\"panel panel-default data-table {{cssClass}}\">\n      <!--<div class=\"panel-heading text-center\">Panel heading</div>-->\n      <div class=\"table-view\" *ngIf=\"scrollable\">\n        <table class=\"table {{type ? 'table-' + type : ''}} {{ hover ? 'table-hover': ''}}\">\n          <thead reDataTableHead [columns]=\"columns\" [headTemplate]=\"headTemplate\" [checkable]=\"checkable\"\n                 [allChecked]=\"allChecked\" [dataTableTemplates]=\"dataTableTemplates\"></thead>\n        </table>\n      </div>\n\n      <div class=\"table-view\" [ngClass]=\"{'scroll-view': scrollable}\" [style.max-height]=\"maxHeight\">\n        <table class=\"table {{type ? 'table-' + type : ''}} {{ hover ? 'table-hover': ''}}\">\n          <thead *ngIf=\"!scrollable\" reDataTableHead [dataTableTemplates]=\"dataTableTemplates\" [columns]=\"columns\"\n                 [headTemplate]=\"headTemplate\" [checkable]=\"checkable\" [allChecked]=\"allChecked\"></thead>\n\n          <tbody reDataTableBody [dataTableTemplates]=\"dataTableTemplates\" [dataSource]=\"dataSource\" [columns]=\"columns\"\n                 [checkable]=\"checkable\" [allChecked]=\"allChecked\" [selectable]=\"selectable\"\n                 [editModel]=\"editModel\" [editRowItem]=\"editRowItem\"></tbody>\n          <tfoot *ngIf=\"footTemplate\" reDataTableFoot [footTemplate]=\"footTemplate\"></tfoot>\n        </table>\n      </div>\n      <div class=\"panel-footer table-view-footer text-center\" *ngIf=\"pager\">\n        <re-data-table-pager [pager]=\"pager\" [dataTableTemplates]=\"dataTableTemplates\"\n                             [pagerTemplate]=\"pagerTemplate\"></re-data-table-pager>\n      </div>\n    </div>\n  ",
        styles: ["\n    .data-table{border:none}.data-table .table-view{padding:0px;border:none}.data-table .table-view .table{margin:0px}.data-table .table-view.scroll-view{overflow:auto}.data-table .table-view-footer{border:none;margin:0px}:host /deep/ .table-pagination .pagination{margin:0px}:host /deep/ .checkable-cell{width:25px}\n  "],
        changeDetection: ChangeDetectionStrategy.OnPush,
        exportAs: 'dataTable'
    })
], DataTableComponent);
export { DataTableComponent };
//# sourceMappingURL=data-table.component.js.map